import random
import math
random.seed("personal03/dragon-eye")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        print('Generating samples...')
        self.print_test("111111")
        self.print_test("010101")
        self.print_test("1")

    def generate_hand_tests(self):
        self.print_test("000")
        self.print_test("001")
        self.print_test("010")
        self.print_test("011")
        self.print_test("100")
        self.print_test("101")
        self.print_test("110")
        self.print_test("111")
        self.print_test("0")
        self.print_test("00")
        self.print_test("01")
        self.print_test("10")
        self.print_test("11")

    def generate_max_tests(self, maxn):
        pass

    def generate_random_test(self, n):
        pl = random.randint(1, n // 3)
        pr = random.randint(1, n // 3)
        if random.randint(1, 2) == 1:
            d = [0, 1]
        else:
            d = [1, 0]
        s = ""
        for i in range(pl):
            s += chr(ord('0') + d[0])            
        for i in range(n - pl - pr):
            s += chr(ord('0') + random.randint(0, 1))
        for i in range(pr):
            s += chr(ord('0') + d[1])
        self.print_test(s)

    def generate_subtask1(self):
        print('Generating subtask1...')
        self.generate_hand_tests()
        for n in [5, 10, 20, 30, 40, 50]:
            self.generate_random_test(n)
        self.print_test("1" * 50)
        self.print_test("0" * 50)
        self.print_test("0" * 25 + "1" * 25)
        self.print_test("1" * 25 + "0" * 25)
        self.print_test("0" * 49 + "1")
        self.print_test("1" * 49 + "0")
        self.print_test("1" + "0" * 49)
        self.print_test("0" + "1" * 49)
        self.print_test("0" * 34 + "1" * 16)
        self.print_test("0" * 16 + "1" * 34)

    def generate_subtask2(self):
        print('Generating subtask2...')
        for n in [100, 200, 300, 400, 500]:
            self.generate_random_test(n)
        self.print_test("1" * 500)
        self.print_test("0" * 500)
        self.print_test("0" * 250 + "1" * 250)
        self.print_test("1" * 250 + "0" * 250)
        self.print_test("0" * 340 + "1" * 160)
        self.print_test("0" * 160 + "1" * 340)

    def generate_subtask3(self):
        print('Generating subtask3...')
        for n in [9200, 9400, 9600, 9800, 10000]:
            self.generate_random_test(n)
        self.print_test("1" * 10000)
        self.print_test("0" * 10000)
        self.print_test("0" * 5000 + "1" * 5000)
        self.print_test("1" * 5000 + "0" * 5000)
        self.print_test("0" * 6600 + "1" * 3400)
        self.print_test("0" * 3400 + "1" * 6600)
            
    def generate_subtask4(self):
        print('Generating subtask4...')
        for n in [10**4, 2 * 10**4, 3 * 10**4, 5 * 10**4, 10**5, 10**6]:
            self.generate_random_test(n)
        self.print_test("1" * 10**6)
        self.print_test("0" * 10**6)
        self.print_test("0" * (10**6 // 2) + "1" * (10**6 // 2))
        self.print_test("1" * (10**6 // 2) + "0" * (10**6 // 2))
        self.print_test("0" * (10**6 // 3) + "1" * (10**6 - 10**6 // 3))
        self.print_test("0" * (10**6 - 10**6 // 3) + "1" * (10**6 // 3))

    def print_test(self, s):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)
        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(s, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()

        self.generate_subtask1()
        self.generate_subtask2()
        self.generate_subtask3()
        self.generate_subtask4()

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
