#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

struct point {
	ll x, y;
	point(ll _x, ll _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator-() const {
		return point(-x, -y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

ll scalar(point const& p1, point const& p2) {
	return p1.x * p2.x + p1.y * p2.y;
}

bool cmp(point const& p1, point const& p2) {
	bool fl1 = p1.x < 0 || (p1.x == 0 && p1.y < 0);
	bool fl2 = p2.x < 0 || (p2.x == 0 && p2.y < 0);
	if (fl1 != fl2) {
		return fl1 < fl2;
	}
	return cross(p1, p2) > 0;
}

bool intersects(vector<point> poly1, vector<point> poly2) {
	for (auto& p : poly2) {
		p = -p;
	}

	int mem = 0;
	vector<point> sides;
	for (int i = 0; i < szof(poly1); ++i) {
		int next = (i + 1) % szof(poly1);
		sides.push_back(poly1[next] - poly1[i]);
		if (poly1[i] < poly1[mem]) {
			mem = i;
		}
	}
	rotate(poly1.begin(), poly1.begin() + mem, poly1.end());
	point cur = poly1[0];

	mem = 0;
	for (int i = 0; i < szof(poly2); ++i) {
		int next = (i + 1) % szof(poly2);
		sides.push_back(poly2[next] - poly2[i]);
		if (poly2[i] < poly2[mem]) {
			mem = i;
		}
	}
	rotate(poly2.begin(), poly2.begin() + mem, poly2.end());

	cur = cur + poly2[0];

	int c1 = 0, c2 = 0;

	while (c1 < szof(poly1) || c2 < szof(poly2)) {
		point shift(0, 0);
		int next1 = c1 + 1;
		if (next1 == szof(poly1)) {
			next1 = 0;
		}
		int next2 = c2 + 1;
		if (next2 == szof(poly2)) {
			next2 = 0;
		}

		if (c1 == szof(poly1) || (c2 != szof(poly2) && cross(poly1[next1] - poly1[c1], poly2[next2] - poly2[c2]) < 0)) {
			shift = poly2[next2] - poly2[c2];
			c2++;
		} else {
			shift = poly1[next1] - poly1[c1];
			c1++;
		}
		if (cross(shift, -cur) < 0) {
			return false;
		}
		// cerr << cur << endl;
		cur = cur + shift;
	}
	return true;
}

int MAXN = 200, MAXK = 500;
const int MAXC = 1000000000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	if (validator.group() == "1") {
		MAXN = 10;
		MAXK = 3;
	} else if (validator.group() == "2") {
		MAXN = 30;
		MAXK = 30;
	} else if (validator.group() == "3") {
		MAXN = 70;
		MAXK = 70;
	} else if (validator.group() == "4") {
		MAXN = 200;
		MAXK = 200;
	}

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int a = inf.readInt(1, n, "a");
	inf.readSpace();
	int b = inf.readInt(1, n, "b");
	inf.readEoln();

	vector<vector<point>> polys;

	for (int i = 0; i < n; ++i) {
		int k = inf.readInt(3, MAXK, format("k_%d", i + 1));
		inf.readEoln();
		polys.push_back({});
		for (int j = 0; j < k; ++j) {
			int x = inf.readInt(-MAXC, MAXC, format("x_{%d, %d}", i + 1, j + 1));
			inf.readSpace();
			int y = inf.readInt(-MAXC, MAXC, format("y_{%d, %d}", i + 1, j + 1));
			inf.readEoln();
			polys.back().push_back(point(x, y));
		}

		double sum = 0;
		for (int j = 0; j < k; ++j) {
			int next = (j + 1) % k;
			int nnext = (j + 2) % k;
			point v1 = polys[i][next] - polys[i][j];
			point v2 = polys[i][nnext] - polys[i][next];
			ensuref(cross(v1, v2) > 0, "every angle should rotate counter clockwise, polygon %d, angle %d, cross = %lld", i + 1, next + 1, cross(v1, v2));
			sum += atan2(cross(v1, v2), scalar(v1, v2));
		}

		ensuref(abs(sum - PI * 2) < 0.5, "there should be one full turn");
	}

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ensuref(!intersects(polys[i], polys[j]), "polygons %d and %d are intersecting", i + 1, j + 1);
		}
	}

	inf.readEof();

	return 0;
}