#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef ONPC
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 5e5 + 7;

vector <int> g[N];
int col[N];
int par[N];
vector <int> gr[N];

vector <int> t;

void dfs(int v)
{
  col[v] = 1;
  for (int to : g[v])
  {
    if (!col[to])
    {
      dfs(to);
    }
    else if (col[to] == 1)
    {
      cout << "No\n";
      exit(0);
    }
  }
  col[v] = 2;
  t.push_back(v);
}

int tt = 0; 

int tin[N], tout[N];

void zhfs(int v)
{
  tin[v] = tt++;
  for (int to : gr[v])
  {
    zhfs(to);
  }
  tout[v] = tt++;
}

bool pr(int a, int b)
{
  return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int main()
{
#ifdef ONPC
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++)
  {
    int a, b;
    cin >> a >> b;
    a--, b--;
    g[a].push_back(b);
  }
  reverse(t.begin(), t.end());
  for (int i = 0; i < n; i++)
  {
    par[i] = -1;
  }
  for (int i = 0; i < n; i++)
  {
    if (!col[i])
    {
      dfs(i);
    }
  }
  for (int v : t)
  {
    for (int to : g[v])
    {
      if (par[to] == -1)
      {
        par[to] = v;
      }
    }
  }
  int root = -1;
  for (int i = 0; i < n; i++)
  {
    if (par[i] == -1)
    {
      if (root != -1)
      {
        cout << "No\n";
        return 0;
      }
      root = i;
    }
  }
  zhfs(root);
  for (int i = 0; i < n; i++)
  {
    for (int to : g[i])
    {
      if (!pr(i, to))
      {
        cout << "No\n";
        return 0;
      }
    }
  }
  cout << "Yes\n";
  for (int i = 0; i < n; i++)
  {
    if (par[i] == -1) par[i]--;
    cout << par[i] + 1 << ' ';
  }
  cout << endl;
}
