#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define mp make_pair
#define ff first
#define ss second

const int maxn = 500179;
vector<int> graph[maxn];
vector<int> rgraph[maxn];

vector<int> used;
vector<int> ts;
bool topsort(int v) {
    used[v] = 1;
    for (int u : graph[v]) {
        if (!used[u]) {
            if (topsort(u)) {
                return true;
            }
        } else if (used[u] == 1) {
            return true;
        }
    }
    used[v] = 2;
    ts.pb(v);
    return false;
}

vector<int> tree[maxn];
vector<int> tin, tout;
int ct = 0;
void dfs(int u) {
    tin[u] = ct++;
    for (int v : tree[u])
        dfs(v);
    tout[u] = ct++;
}

bool is_ancestor(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    forn(i, m) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].pb(v);
        rgraph[v].pb(u);
    }

    used.assign(n, 0);
    forn(i, n) {
        if (used[i] == 0 && topsort(i)) {
            cerr << 1 << endl;
            cout << "No" << endl;
            return 0;
        }
    }
    reverse(all(ts));
    vector<int> tspos(n);
    forn(i, n)
        tspos[ts[i]] = i;

    vector<int> parent(n, -1);
    queue<int> leaves;
    forn(i, n) {
        if (graph[i].empty())
            leaves.push(i);
    }
    vector<int> deg(n);
    forn(i, n)
        deg[i] = graph[i].size();

    int dec = 0;
    int root = -1;
    while (!leaves.empty()) {
        int a = leaves.front();
        leaves.pop();
        for (int u : rgraph[a]) {
            if (parent[a] == -1 || tspos[parent[a]] < tspos[u]) {
                parent[a] = u;
            }
            --deg[u];
            if (deg[u] == 0) {
                leaves.push(u);
            }
        }
        if (parent[a] != -1) {
            ++dec;
            tree[parent[a]].pb(a);
        } else {
            root = a;
        }
    }

    if (dec != n - 1) {
        cerr << 2 << endl;
        cout << "No" << endl;
        return 0;
    }

    tin.resize(n);
    tout.resize(n);
    dfs(root);

    forn(i, n) {
        for (int u : graph[i]) {
            if (!is_ancestor(i, u)) {
                cout << "No" << endl;
                return 0;
            }
        }
    }

    cout << "Yes" << endl;
    forn(i, n) {
        if (i == root)
            cout << -1 << " ";
        else
            cout << parent[i] + 1 << " ";
    }
    cout << endl;

    return 0;
}
